#include "lcd.h"

const char dat_lcd = 0x01; 		//send data
const char cmd_lcd = 0x00; 		//send command

const unsigned int E  = 0x40000000; // P0.30
const unsigned int RS = 0x80000000; // P0.31
const char cmd_bit = 31;


void LCDDelay (void) 
{ 
  unsigned int i;
  
  for(i = 0; i < 0x100; i++);	   
}								    


// ustawia kursor na wsprzdnych x, y
void LCDGotoXY(char x, char y)
{
	switch (y)			//obliczenie o ile naley zwikszy
 					    //x w zalenoci od wartoci y
	{
		case 0:
			x += 0x80;	//x = x + 0x80
			break;
		case 1:
			x += 0xC0;	//x = x + 0xC0
			break;
		case 2:
			x += 0x94;	//x = x + 0x94
			break;
		case 3:
			x += 0xD4;	//x = x + 0xD4
			break;
	}
	LCDSendByte( x , cmd_lcd );
}


//wywietla tekst rozpoczynajc od aktualnego pooenia kursora
void LCDText(char *T)
{
	while (*T)			//ptla dziaa, a napotka 
		LCDSendByte(*T++,dat_lcd);		//wywietlenie pojedynczego znaku
}

//wywietla tekst rozpoczynajc od wsp. (X,Y)
void LCDTextXY(char x, char y, char *T)
{
	while (*T)
	{
		LCDGotoXY(x, y);
		LCDSendByte(*T,dat_lcd);		//wywietlenie pojedynczego znaku
		x++; 			//nastpna pozycja x na ekranie
		T++;			//nastpny znak napisu
		if (x > 19)		//jeli x>19 to nastpna linia
		{
			x = 0; 
			y++;
		}
	}
}				   

void LCDSendByte(unsigned int data_lcd,unsigned int cmd)
{
  IOCLR0 = 0xFFFFFFFF & (E | RS);
  LCDDelay();
  IOCLR1 = 0x00FF0000;
  LCDDelay();

  // RS=cmd, E=0
  IOSET0 = 0x00000000 | (cmd << cmd_bit);                  LCDDelay();   
  // Set data
  IOSET1 = ((data_lcd & 0xFF) << 16) & 0x00FF0000;    LCDDelay();
  // RS=cmd, E=1
  IOSET0 = (0xFF000000 & E) | (cmd << cmd_bit);			  LCDDelay();   	 
  // RS=cmd, E=0
  IOCLR0 = (0xFF000000 & E);

  IOCLR1 = 0x00FF0000;		                          LCDDelay();
} 

void LCDInit(void)
{
   LCDSendByte(0x30,cmd_lcd);	LCDDelay();  LCDDelay();  LCDDelay();
   LCDSendByte(0x30,cmd_lcd);	LCDDelay();  LCDDelay();  LCDDelay();
   LCDSendByte(0x30,cmd_lcd);   LCDDelay();  LCDDelay();  LCDDelay();

   LCDSendByte(0x38,cmd_lcd);   LCDDelay();
   LCDSendByte(0x0C,cmd_lcd);   LCDDelay();   
   LCDSendByte(0x06,cmd_lcd);   LCDDelay();   
   LCDSendByte(0x01,cmd_lcd);   LCDDelay();   
   LCDSendByte(0x02,cmd_lcd);   LCDDelay();   

}

void LCDClear(void)
{
  int i;
  LCDSendByte(0x01,0);
  for(i = 0; i < 0x10000; i++);
}
